<?php

class Block {
    public $title;
    public $items = [];
}


function str_startswith ($str, $search)
{
    return (substr ($str, 0, strlen ($search)) === $search);
}


function str_endswith ($str, $search)
{
    return (substr ($str, -strlen ($search)) === $search);
}


function array_get ($array, $key)
{
  return isset ($array[$key]) ? $array[$key] : NULL;
}


function pre_dump ($value)
{
  echo "<pre>\n";
  var_dump ($value);
  echo "</pre>\n";
}

function get_nonempty_line ($file)
{
    while (TRUE)
    {
        $line = fgets ($file);
        if ($line === FALSE) return FALSE;

        $len = strlen ($line);
        for ($i = 0; $i < $len; ++$i)
        {
            $c = $line[$i];
            if ($c !== ' ' && $c !== "\n")
            {
                return $line;
            }
        }
    }
}


function get_block ($file, &$line)
{
    if ($line === NULL)
    {
        $line = get_nonempty_line ($file);
        if ($line === FALSE) return NULL;
    }

    $block = new Block ();
    $block->title = $line;

    if ($block->title[0] === ' ')
    {
        poll_error ("Invalid indentation for block title: $block->title");
        return FALSE;
    }

    $block->title = trim ($block->title);

    if (substr ($block->title, -1) !== ':')
    {
        poll_error ("Block title must end with ':': $block->title");
        return FALSE;
    }

    while (($line = get_nonempty_line ($file)))
    {
        if ($line[0] !== ' ') break;
        array_push ($block->items, trim ($line));
    }

    return $block;
}


?>
