<?php

function get_news_article_title ($title_line)
{
  $title = substr ($title_line, 4, -6);
  $title = htmlspecialchars ($title);
  return $title;
}


function get_news_dirnames ($news_root_dirpath)
{
  $dirpaths = [];
  $root_dir = opendir ($news_root_dirpath);

  while (($article = readdir ($root_dir)) !== FALSE)
    {
      if ($article[0] !== '2') continue;
      $article_dirpath = $article;
      array_push ($dirpaths, $article_dirpath);
    }
  closedir ($root_dir);

  return $dirpaths;
}


function get_news_article_date_string ($dirpath)
{
  $d = substr ($dirpath, 0, 4) . '.' .
       substr ($dirpath, 4, 2) . '.' .
       substr ($dirpath, 6, 2);
  return $d;
}


function show_news_articles ($news_dirpath, $limit=5)
{
  $dirnames = get_news_dirnames ($news_dirpath);
  rsort ($dirnames);

  if ($limit === 0 || count ($dirnames) < $limit)
    {
      $shown_articles_count = count ($dirnames);
    }
  else
    {
      $shown_articles_count = $limit;
    }

  for ($article_index = 0; $article_index < $shown_articles_count; ++$article_index)
    {
      $dirname = $dirnames[$article_index];
      $publish_time = get_news_article_date_string ($dirname);
      $dirpath = $news_dirpath . '/' . $dirname;

      $filepath = $dirpath . '/_page.php';
      $file = fopen ($filepath, 'r');
      $title_line = fgets ($file);
      while (($line = fgets ($file)) === "\n");
      $summary = $line;
      fclose ($file);

      echo "<article class=\"news-headline\">\n";
      echo "  <p class=\"image\"><a href=\"/$dirpath/\"><img src=\"/$dirpath/_thumbnail.png\" width=\"240\" height=\"135\" title=\"Прочети тази новина\"/></a></p>\n";
      echo "    $title_line";
      echo "    <p class=\"date\">$publish_time</p>\n";
      echo "    $summary";
      echo "    <p class=\"button\"><a href=\"/$dirpath/\"><img src=\"/_res/widgets/goto_button.png\" width=\"40\" height=\"40\" title=\"Прочети тази новина\"/></a></p>\n";
      echo "</article>\n";
    }
}
?>
